var click2tabSettings = 
{
    VKNames : [],
    platformKeys : null,

    initKeyNames : function ()
    {
        var platformKeysStringBundle = document.getElementById('click2tabPlatformKeys');
        this.platformKeys = [];
        this.platformKeys.Shift = platformKeysStringBundle.getString("VK_SHIFT");
        this.platformKeys.Meta = platformKeysStringBundle.getString("VK_META");
        this.platformKeys.Alt = platformKeysStringBundle.getString("VK_ALT");
        this.platformKeys.Ctrl = platformKeysStringBundle.getString("VK_CONTROL");
        this.platformKeys.Sep = platformKeysStringBundle.getString("MODIFIER_SEPARATOR");
        for (var vKey in KeyEvent)
            this.VKNames[KeyEvent[vKey]] = vKey.replace("DOM_", "");
    },

    FormatKeys : function (keyStringArray)
    {
        var keyStrings = "";

        if (keyStringArray[0])
            keyStrings = keyStringArray[0].replace(",", this.platformKeys.Sep)
                                          .replace("shift", this.platformKeys.Shift)
                                          .replace("meta", this.platformKeys.Meta)
                                          .replace("alt", this.platformKeys.Alt)
                                          .replace("control", this.platformKeys.Ctrl) + this.platformKeys.Sep;
        if (keyStringArray[1])
            keyStrings += keyStringArray[1];
        else
            keyStrings += keyStringArray[2];

        return keyStrings;
    },

    onLoad : function ()
    {
        this.prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch(null);
        this.initKeyNames();

        this.click2tabReopenInBackground = document.getElementById('click2tabReopenInBackground');
        this.click2tabIndexInTabList = document.getElementById('click2tabIndexInTabList');
        this.click2tabRightClickTabToRemove = document.getElementById('click2tabRightClickTabToRemove');
        this.click2TabSaveClosedTabs = document.getElementById('click2TabSaveClosedTabs');
        this.click2tabSaveOpenTabs = document.getElementById('click2tabSaveOpenTabs');
        this.click2tabClosedCacheSize = document.getElementById('click2tabClosedCacheSize');
        this.click2tabClosedListLength = document.getElementById('click2tabClosedListLength');
        this.click2tabShowMoreSubmenu = document.getElementById('click2tabShowMoreSubmenu');

        this.click2tabCtlWCloseTab = document.getElementById('click2tabCtlWCloseTab');
        this.click2tabClearHistory = document.getElementById('click2tabClearHistory');

        this.click2tabBookmark = document.getElementById('click2tabBookmark');
        this.click2tabHistory = document.getElementById('click2tabHistory');
        this.click2tabUseMiddleClick = document.getElementById('click2tabUseMiddleClick');

        this.click2tabCloseTabButtonContext = document.getElementById('click2tabCloseTabButtonContext');
        this.click2tabCloseTabButtonMiddleClick = document.getElementById('click2tabCloseTabButtonMiddleClick');
        this.click2tabReopenTabContext = document.getElementById('click2tabReopenTabContext');
        this.click2tabReopenTabsTabContext = document.getElementById('click2tabReopenTabsTabContext');
        this.click2TabReplaceGoMenuItem = document.getElementById('click2TabReplaceGoMenuItem');
        this.click2tabShortcutKeyUndo = document.getElementById('click2tabShortcutKeyUndo');

        // Set the initial UI state
        this.click2tabReopenInBackground.checked = this.prefService.getBoolPref(prefStringClick2TabReopenInBackground);
        this.click2tabIndexInTabList.checked = this.prefService.getBoolPref(prefStringClick2TabIndexInTabList);
        this.click2tabRightClickTabToRemove.checked = this.prefService.getBoolPref(prefStringClick2TabRightClickTabToRemove);
        this.click2TabSaveClosedTabs.checked = this.prefService.getBoolPref(prefStringClick2TabSaveClosedTabs);
        this.click2tabSaveOpenTabs.checked = this.prefService.getBoolPref(prefStringClick2TabSaveOpenTabs);
        this.click2tabClosedCacheSize.value = this.prefService.getIntPref(prefStringClick2TabClosedCacheSize);
        this.click2tabClosedListLength.value = this.prefService.getIntPref(prefStringClick2TabClosedListLength);
        this.click2tabShowMoreSubmenu.checked = this.prefService.getBoolPref(prefStringClick2TabShowMoreSubmenu);

        this.click2tabCtlWCloseTab.checked = this.prefService.getBoolPref(prefStringClick2TabCtlWCloseTab);
        this.click2tabClearHistory.checked = this.prefService.getBoolPref(prefStringClick2TabClearHistory);
        this.togglePrefUI(this.click2tabCtlWCloseTab);

        this.click2tabBookmark.checked = this.prefService.getBoolPref(prefStringClick2TabBookmark);
        this.click2tabHistory.checked = this.prefService.getBoolPref(prefStringClick2TabHistory);
        this.click2tabUseMiddleClick.checked = this.prefService.getBoolPref(prefStringClick2TabUseMiddleClick);

        this.click2tabCloseTabButtonContext.checked = this.prefService.getBoolPref(prefStringClick2TabCloseTabButtonContext);
        this.click2tabCloseTabButtonMiddleClick.checked = this.prefService.getBoolPref(prefStringClick2TabCloseTabButtonMiddleClick);
        this.click2tabReopenTabContext.checked = this.prefService.getBoolPref(prefStringClick2TabReopenTabContext);
        this.click2tabReopenTabsTabContext.checked = this.prefService.getBoolPref(prefStringClick2TabReopenTabsTabContext);
        this.click2TabReplaceGoMenuItem.checked = this.prefService.getBoolPref(prefStringClick2TabReplaceGoMenuItem);

        this.click2tabShortcutKeyUndo.keys = this.prefService.getCharPref(prefStringClick2TabShortcutKeyUndo).split("][");
        this.click2tabShortcutKeyUndo.value = this.FormatKeys(this.click2tabShortcutKeyUndo.keys);
    },

    onAccept : function ()
    {
        var strNumRegEx = /^ *[0-9]+ *$/;
        var click2tabSettingStringBundle = document.getElementById('click2tabSettingStrings');
        if (!strNumRegEx.test(this.click2tabClosedCacheSize.value)
            || (this.click2tabClosedCacheSize.value == 0))
        {
            alert(click2tabSettingStringBundle.getString('click2tab.settings.cacheSizeInvalid'));
            this.click2tabClosedCacheSize.select();
            this.click2tabClosedCacheSize.focus();
            return false;
        }
        if (!strNumRegEx.test(this.click2tabClosedListLength.value)
            || (this.click2tabClosedListLength.value == 0))
        {
            alert(click2tabSettingStringBundle.getString('click2tab.settings.listLengthInvalid'));
            this.click2tabClosedCacheSize.select();
            this.click2tabClosedListLength.focus();
            return false;
        }

        this.prefService.setBoolPref(prefStringClick2TabReopenInBackground, this.click2tabReopenInBackground.checked);
        this.prefService.setBoolPref(prefStringClick2TabIndexInTabList, this.click2tabIndexInTabList.checked);
        this.prefService.setBoolPref(prefStringClick2TabRightClickTabToRemove, this.click2tabRightClickTabToRemove.checked);
        this.prefService.setBoolPref(prefStringClick2TabSaveClosedTabs, this.click2TabSaveClosedTabs.checked);
        this.prefService.setBoolPref(prefStringClick2TabSaveOpenTabs, this.click2tabSaveOpenTabs.checked);
        this.prefService.setIntPref(prefStringClick2TabClosedCacheSize, this.click2tabClosedCacheSize.value);
        this.prefService.setIntPref(prefStringClick2TabClosedListLength, this.click2tabClosedListLength.value);
        this.prefService.setBoolPref(prefStringClick2TabShowMoreSubmenu, this.click2tabShowMoreSubmenu.checked);

        this.prefService.setBoolPref(prefStringClick2TabCtlWCloseTab, this.click2tabCtlWCloseTab.checked);
        this.prefService.setBoolPref(prefStringClick2TabClearHistory, this.click2tabClearHistory.checked);

        this.prefService.setBoolPref(prefStringClick2TabBookmark, this.click2tabBookmark.checked);
        this.prefService.setBoolPref(prefStringClick2TabHistory, this.click2tabHistory.checked);
        this.prefService.setBoolPref(prefStringClick2TabUseMiddleClick, this.click2tabUseMiddleClick.checked);

        this.prefService.setBoolPref(prefStringClick2TabCloseTabButtonContext, this.click2tabCloseTabButtonContext.checked);
        this.prefService.setBoolPref(prefStringClick2TabCloseTabButtonMiddleClick, this.click2tabCloseTabButtonMiddleClick.checked);
        this.prefService.setBoolPref(prefStringClick2TabReopenTabContext, this.click2tabReopenTabContext.checked);
        this.prefService.setBoolPref(prefStringClick2TabReopenTabsTabContext, this.click2tabReopenTabsTabContext.checked);
        this.prefService.setBoolPref(prefStringClick2TabReplaceGoMenuItem, this.click2TabReplaceGoMenuItem.checked);
        this.prefService.setCharPref(prefStringClick2TabShortcutKeyUndo, this.click2tabShortcutKeyUndo.keys.join("]["));
    },

    RecognizeShortcutKey : function (event)
    {
        event.preventDefault();
        event.stopPropagation();

        var modifiers = [];
        if (event.altKey)
            modifiers.push("alt");
        if (event.ctrlKey)
            modifiers.push("control");
        if (event.metaKey)
            modifiers.push("meta");
        if (event.shiftKey)
            modifiers.push("shift");
        modifiers = modifiers.join(",");

        var key = "", keyCode = "";
        if (event.charCode)
        {
            key = String.fromCharCode(event.charCode).toUpperCase();
            if (key == " ")
            {
                this.click2tabShortcutKeyUndo.value = "";
                this.click2tabShortcutKeyUndo.keys = ["", "", ""];
                return;
            }
        }
        else
            keyCode = this.VKNames[event.keyCode];

        this.click2tabShortcutKeyUndo.keys = [modifiers, key, keyCode];
        this.click2tabShortcutKeyUndo.value = this.FormatKeys(this.click2tabShortcutKeyUndo.keys);
        this.click2tabShortcutKeyUndo.select();
    },

    togglePrefUI : function (checkBox)
    {
        if (checkBox.hasAttribute("controlledElement"))
        {
            controlledElement = document.getElementById(checkBox.getAttribute("controlledElement"));
            if (checkBox.checked)
                controlledElement.removeAttribute("disabled");
            else
                controlledElement.setAttribute("disabled", "true");
        }
    }
};